/*
	config.c
	By Tuxgasy <tuxgasy@tuxfamily.org>
	
	This file is part of Glda.
	
	You may redistribute it and/or modify it under the terms of the
	GNU General Public License, as published by the Free Software
	Foundation; either version 2 of the License, or (at your option) any later version.
	
	Glda is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
	See the GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with Glda; if not, write to the Free Software
	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <libxml/tree.h>
#include <libxml/parser.h>
#include <libxml/xpath.h>
#include <glib.h>
#include <glib/gstdio.h>
#include <gtk/gtk.h>

#include "../inc/interface.h"
#include "../inc/magasin.h"
#include "../inc/lda.h"
#include "../inc/main.h"

GKeyFile *initConfig(){
	GKeyFile* ConfigLda;
	/*char fileUserConfig[30];*/
	gchar *fileUserConfig;
	gchar *dirUserConfig;
	gchar *sText;
	
	ConfigLda = g_key_file_new();
	
	/*sprintf(fileUserConfig, "%s%s%s", getenv("HOME"), DIR_USER_CONFIG, FILE_USER_CONFIG);*/
	fileUserConfig = g_strdup_printf("%s%s%s", getenv("HOME"), DIR_USER_CONFIG, FILE_USER_CONFIG);
	
	if(g_file_test(fileUserConfig, G_FILE_TEST_EXISTS) == FALSE){
		dirUserConfig = g_strdup_printf("%s%s", getenv("HOME"), DIR_USER_CONFIG);
		if(g_file_test(dirUserConfig, G_FILE_TEST_IS_DIR) == FALSE){
			if(g_mkdir(dirUserConfig, 0750) == -1){
				g_free(dirUserConfig);
				g_free(fileUserConfig);
				return NULL;
			}
			g_free(dirUserConfig);
		}
		sText = g_strdup_printf("cp /etc/glda/glda.conf.default %s", fileUserConfig);
		system(sText);
		g_free(sText);
	}
	
	if(g_key_file_load_from_file(ConfigLda, (const gchar*)fileUserConfig, G_KEY_FILE_NONE, NULL) == FALSE){
		fprintf(stderr, "Impossible de charger le fichier de config...\n");
		g_free(fileUserConfig);
		return NULL;
	}
	
	g_free(fileUserConfig);
	return ConfigLda;
}

gchar *getUserLang(GKeyFile* ConfigLda){
	return g_key_file_get_string(ConfigLda, "general", "lang", NULL);
}

gchar *getUserDevise(GKeyFile* ConfigLda){
	return g_key_file_get_string(ConfigLda, "general", "devise", NULL);
}
void freeConfig(GKeyFile* ConfigLda){
	g_key_file_free(ConfigLda);
}
